package org.dromara.system.service;

import org.dromara.common.core.domain.R;
import org.dromara.system.domain.CourseTable;
import org.dromara.system.domain.vo.CourseTableVo;
import org.dromara.system.domain.bo.CourseTableBo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 课程Service接口
 *
 * @author Lion Li
 * @date 2023-08-16
 */
public interface ICourseTableService {

    /**
     * 查询课程
     */
    CourseTableVo queryById(Long id);

    /**
     * 查询课程列表
     */
    TableDataInfo<CourseTableVo> queryPageList(CourseTableBo bo, PageQuery pageQuery);

    /**
     * 查询课程列表
     */
    List<CourseTableVo> queryList(CourseTableBo bo);

    /**
     * 新增课程
     */
    R<Void> insertByBo(CourseTableBo bo);

    /**
     * 修改课程
     */
    Boolean updateByBo(CourseTableBo bo);

    /**
     * 校验并批量删除课程信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    R<Map<String, Object>> now(Long schoolId, Long classId);

    TableDataInfo<CourseTableVo> queryPagePcList(CourseTableBo bo, PageQuery pageQuery);
}
